#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

#include <QFileDialog>

void MainWindow::on_action_Open_triggered()
{
    QString name =
      QFileDialog::getOpenFileName (this, "Open XML file");
    this->statusBar()->showMessage ("File name: " + name);
    if (name != "")
        run (name);
}


void MainWindow::on_action_Run_triggered()
{
    run ("../structure/mainwindow.ui");
}

void MainWindow::on_action_Quit_triggered()
{
    close ();
}

#include <QFile>
#include <QXmlStreamReader>
#include <QUiLoader>
/* dnf install qt5-qttools-static */
/* structure.pro    QT += core gui uitools */

void MainWindow::run (QString path)
{
   this->statusBar()->showMessage ("Run: " + path);
   QFile f (path);
   if (f.open (QFile::ReadOnly | QFile::Text))
   {
      QUiLoader loader;
      QWidget * w = loader.load (&f, this);
      w->show();
      f.reset(); // navrat na zacatek

      QTreeWidgetItem * target =
              ui->treeWidget->invisibleRootItem();
      QXmlStreamReader r (&f);
      while (!r.atEnd())
      {
          r.readNext();
          if (r.isStartElement())
          {
             QTreeWidgetItem * node = new QTreeWidgetItem;
             node->setText (0, r.name().toString());
             node->setForeground(0, QColor ("red"));
             target->addChild (node);
             target = node;
          }
          else if (r.isEndElement())
          {
              target = target->parent();
          }
          else if (r.isCharacters())
          {
              QTreeWidgetItem * node = new QTreeWidgetItem;
              QString s = r.text ().toString().simplified();
              if (s != "")
              {
                 node->setText (0, s);
                 node->setForeground(0, QColor ("blue"));
                 target->addChild (node);
              }
          }
      }

      f.close ();
   }
}
